//                           //
// Serial In Out             //
//                           //
// Olaf Val                  //
// www.olafval.de/workshop   //
//                           //

import processing.serial.*;

Serial comPort;        // The serial port
int comNum = 1; // Nummer of comPort in comPortList (devault:0)
String inString;  // Variable for Serial Data
int sentKey = -1;  // Keyboard Key to bee sent
PFont fontA;        // Font for printing

void setup() {
  size(200, 400);

  // Load and prep fonts to print to window
  fontA = loadFont("CourierNewPSMT-24.vlw");
  textFont(fontA, 24);

  // List all the available serial ports.
  println(Serial.list());
  comPort = new Serial(this, Serial.list()[comNum], 9600);
}

void draw() {
  background(0);
  text("Sent: ", 10, 40);
  text(char(sentKey), 10, 60);  
  text("Received: ", 10, 100);
  text("" + inString, 10, 120);

  // If there are bytes available in the input ComPortBuffer, read them into inString.
  while (comPort.available() > 0) {
    inString = comPort.readString();
  }
}
// if a key is pressed, send it to the comPort.
void keyPressed() {
  comPort.write(key);
  sentKey = key;
}
